In-line run of subs_in_out so that it gets the environment more easily.
[libdcp.git] / run / tests
index f5dc7746bbdfddada832574bb995b8e798f070e8..f4e8d405ff1d9355d68274c6a3d4b3834f52e2f3 100755 (executable)
--- a/run/tests
+++ b/run/tests
@@ -6,43 +6,70 @@
 private=../libdcp-test-private
 # Work directory
 work=build/test
-# Path to dcpinfo tool
+# Path to tools
 dcpinfo=build/tools/dcpinfo
+dcpverify=build/tools/dcpverify
+
+type=""
+while [[ $# -gt 0 ]]; do
+    case $1 in
+        -e)
+        environment=$2
+        shift
+        shift
+        ;;
+        --debug)
+        type="debug"
+        shift
+        ;;
+        --valgrind)
+        type="valgrind"
+        shift
+        ;;
+        --callgrind)
+        type="callgrind"
+        shift
+        ;;
+        *)
+        break
+        ;;
+    esac
+done
 
-export LD_LIBRARY_PATH=build/src:/home/c.hetherington/lib:$LD_LIBRARY_PATH
+export LD_LIBRARY_PATH=build/src:/usr/local/lib:/usr/local/lib64:$LD_LIBRARY_PATH
+# SIP stops this being passed in from the caller's environment
+export DYLD_LIBRARY_PATH=$environment/x86_64/10.10/lib:/Users/ci/workspace/lib
+export LIBDCP_RESOURCES=.
 
 # Make sure we have the required tools
-for c in xmlsec1 xmldiff xmllint; do
+for c in xmlsec1 xmllint; do
   hash $c 2>/dev/null || { echo >&2 "$c required but not found; aborting"; exit 1; }
 done
 
+echo "--- Unit tests"
+
 # Run the unit tests in test/
-if [ "$1" == "--debug" ]; then
-    shift
+if [ "$type" == "debug" ]; then
     gdb --args $work/tests $private $*
-elif [ "$1" == "--valgrind" ]; then
-    shift
-    valgrind --tool="memcheck" $work/tests $private
-elif [ "$1" == "--callgrind" ]; then
-    shift
+elif [ "$type" == "valgrind" ]; then
+    valgrind --tool="memcheck" $work/tests $private $*
+elif [ "$type" == "callgrind" ]; then
     valgrind --tool="callgrind" $work/tests $private $*
 else
-    # This gives a warning from newer boost versions but doing it
-    # as $work/tests $* -- $private fails on older boost versions.
-    $work/tests $private $*
+    $work/tests $* -- $private
     if [ "$?" != "0" ]; then
        echo "FAIL: unit tests"
         exit 1
     fi
 fi
 
-# Check a MXF written by the unit tests
-diff $work/baz/video1.mxf $work/baz/video2.mxf
-if [ "$?" != "0" ]; then
-    echo "FAIL: MXFs from recovery incorrect"
-    exit 1
+if [ "$*" != "" ]; then
+    echo "Skipping post-test checks as not all unit tests were run."
+    exit 0
 fi
 
+echo "--- Other tests"
+
 # Check the DCP written by dcp_test1
 diff -ur test/ref/DCP/dcp_test1 $work/DCP/dcp_test1
 if [ "$?" != "0" ]; then
@@ -99,6 +126,17 @@ for d in `find $private/metadata -mindepth 1 -maxdepth 1 -type d | sort -f -d`;
     fi
 done
 
+# Run dcpverify on all the DCPs in private/metadata
+for d in `find $private/metadata -mindepth 1 -maxdepth 1 -type d | sort -f -d`; do
+    if [ `basename $d` != ".git" ]; then
+        $dcpverify --ignore-missing-assets --ignore-bv21-smpte -q $d
+        if [ "$?" != "0" ]; then
+            echo "FAIL: dcpverify failed for $d"
+            exit 1
+        fi
+    fi
+done
+
 # Check info.log is what it should be
 diff -q $work/info.log $private/info.log
 if [ "$?" != "0" ]; then
@@ -106,13 +144,13 @@ if [ "$?" != "0" ]; then
     exit 1
 fi
 
-# Copy $private into build/ then re-write the subtitles of every DCP using
-# $work/rewrite_subs.  This tests round-trip of subtitle reading/writing.
-# Note that all the subs in $private/metadata are Interop.
+# Copy $private/metadata into build/metadata then re-write the subtitles
+# of every DCP using $work/rewrite_subs.  This tests round-trip of
+# subtitle reading/writing.
 rm -f $work/info2.log
 rm -rf $work/private
 mkdir $work/private
-cp -r $private/* $work/private
+cp -r $private/metadata $work/private/
 for d in `find $work/private/metadata -mindepth 1 -maxdepth 1 -type d | sort -f -d`; do
     if [ `basename $d` != ".git" ]; then
         $work/rewrite_subs $d
@@ -121,7 +159,7 @@ for d in `find $work/private/metadata -mindepth 1 -maxdepth 1 -type d | sort -f
 done
 
 # Fudge the output
-sed -i "s/DCP: build\/test/DCP: test/g" $work/info2.log
+sed -i -e "s/DCP: build\/test/DCP: test/g" $work/info2.log
 
 # And check it
 diff -q $work/info2.log $private/info2.log
@@ -135,7 +173,7 @@ fi
 $dcpinfo -s $private/data/JourneyToJah_TLR-1_F_EN-DE-FR_CH_51_2K_LOK_20140225_DGL_SMPTE_OV >> $work/jah.log
 
 # Parse some problematic subs and check that we get it right
-run/test/subs_in_out $private/TunaBoat_Icelandic_Reel1_V1_8sec.xml > $work/tuna.xml
+build/test/subs_in_out $private/TunaBoat_Icelandic_Reel1_V1_8sec.xml > $work/tuna.xml
 diff -q $private/TunaBoat_Icelandic_Reel1_V1_8sec.parsed.xml $work/tuna.xml
 if [ "$?" != "0" ]; then
     echo "FAIL: output of parse check 1 invalid"